#ifndef (use_radiosity) #declare use_radiosity=1; #end

// *** Predefinied car paints ***

// camera vector
#declare cv=(clo-cla);

// paint finishes
#if (use_radiosity<2)

#declare f_matte=
finish{ // metalized mate
 specular 1 metallic roughness .05
 diffuse .5
}
#declare f_varnish=
finish{ // normal varnish
 Shiny
 diffuse .5 reflection{rmin,rmax falloff 5} conserve_energy 
}
#declare f_metallic_varnish=
finish{  // metallized varnish
 specular .5 roughness .0125 
 diffuse .5 reflection{rmin,rmax falloff 5} conserve_energy 
}

#else

#declare f_matte=
finish{diffuse .5}
#declare f_varnish=
finish{diffuse .5}

#end

// paint textures
#declare t_red_paint=
texture{
 pigment{Firebrick*.1+Red*.5}
 finish{f_varnish}
}
#declare t_green_paint=
texture{
 pigment{DarkGreen+Blue*.1}
 finish{f_varnish}
}
#declare t_blue_paint=
texture{
 pigment{NavyBlue+Green*.1}
 finish{f_varnish}
}
#declare t_black_paint=
texture{
 pigment{DarkSlateBlue*.01}
 finish{f_varnish}
}
#declare t_white_paint=
texture{
 pigment{White*.75}
 finish{f_varnish}
}
#declare t_blue_white_bars_paint=
texture{
 pigment{
  function{abs(x)}
  color_map{
   [0.00 DarkSlateBlue*.3+Green*.15+Blue*.15]
   [0.10 DarkSlateBlue*.3+Green*.15+Blue*.15]
   [0.10 White*.5]
   [0.30 White*.5]
   [0.30 DarkSlateBlue*.3+Green*.15+Blue*.15]
   [1.00 DarkSlateBlue*.3+Green*.15+Blue*.15]
  }
 }
 finish{f_varnish}
}

// metallized paint macro
#macro metallized_paint(c1,c2,cv,f_matte,f_varnish)

#local t_metallized_paint=
texture{ // matte layer
 pigment{
  slope cv
  color_map{
   [0.0 rgb c1]
   [1.0 rgb c2]
  }
 }
 #if (metallic_normal)
 normal{bozo 1 turbulence 1 lambda 3 omega 1 scale .01}
 #end
 finish{f_matte} 
}
texture{ // varnish layer
 pigment{rgb c1 transmit .5}
 finish{f_varnish}
}
#local dummy=0;

texture{t_metallized_paint}

#end

// golden paint
#declare c1=Black; #declare c2=Gold;
#if (use_radiosity<2)
#declare t_DarkGold_paint=metallized_paint(c1,c2,cv,f_matte,f_metallic_varnish)
#else
#declare t_DarkGold_paint=texture{pigment{c2}}
#end

// dark silver paint
#declare c1=Black; #declare c2=Silver;
#if (use_radiosity<2)
#declare t_DarkSilver_paint=metallized_paint(c1,c2,cv,f_matte,f_metallic_varnish)
#else
#declare t_DarkSilver_paint=texture{pigment{c2}}
#end

// blue-yellow paint
#declare c1=Blue*.3+Green*.2; #declare c2=Yellow*.5;
#if (use_radiosity<2)
#declare t_BlueYellow_paint=metallized_paint(c1,c2,cv,f_matte,f_metallic_varnish)
#else
#declare t_BlueYellow_paint=texture{pigment{c2}}
#end

// blue-red paint
#if (use_radiosity<2)
#declare c1=Blue*.5; #declare c2=Red*.5;
#declare t_BlueRed_paint=metallized_paint(c1,c2,cv,f_matte,f_metallic_varnish)
#else
#declare t_BlueRed_paint=texture{pigment{c2}}
#end

// yellow-red paint
#if (use_radiosity<2)
#declare c2=Yellow; #declare c1=Red*.5;
#declare t_YellowRed_paint=metallized_paint(c1,c2,cv,f_matte,f_metallic_varnish)
#else
#declare t_YellowRed_paint=texture{pigment{c2}}
#end


// *** Other required textures ***

// car glass
#declare t_glass=
texture{
 #if (use_radiosity<2)
// pigment{Gray10 transmit .99}
 T_Glass1
 finish{
  reflection{.1,.9}
 }
 #else
 pigment{rgbt 1}
 #end
}

// car mirror
#if (use_radiosity<2)
#declare t_mirror=
texture{Mirror}
#else
#declare t_mirror=
texture{pigment{White}}
#end

// car lights
#if (use_radiosity<2)
#declare t_faros=
texture{
 T_Glass2
 normal{quilted 1 scale <.2,.1,.1>*.1}
 finish{reflection{.1,.9}}
}
#else
#declare t_faros=
texture{pigment{rgb 1}}
#end

// car stop lights
#if (use_radiosity<2)
#declare t_stop=
texture{
 pigment{Firebrick}
 normal{quilted scale <.2,.1,.1>*.1}
 finish{F_Glass3}
}
#else
#declare t_stop=
texture{pigment{Firebrick}}
#end

// car iterm. light
#if (use_radiosity<2)
#declare t_interm=
texture{
 pigment{Orange}
 normal{quilted scale <.2,.1,.1>*.1}
 finish{F_Glass3}
}
#else
#declare t_interm=
texture{pigment{Orange}}
#end

// car bajos
#declare t_bajos=
texture{
 pigment{Gray10}
}

// chromed details
#if (use_radiosity<2)
#declare t_chrome=
texture{T_Chrome_3C 
 normal{quilted scale .01}
 finish{ambient 0}
}
#else
#declare t_chrome=
texture{pigment{Gray}}
#end


// black plastic
#declare t_grill=
texture{
 pigment{brick color Gray10 color rgbt 1 mortar 2  scale .005 rotate 90*z} 
 #if (use_radiosity<2)
 finish{Shiny}
 #end
}

// seats
#declare t_seat=
texture{
 pigment{Gray30}
}

// wheel cover metal
#if (use_radiosity<2)
#declare t_wheel_chrome=
texture{T_Chrome_3C
 finish{ambient 0}
}
#declare t_brake_metal=
texture{T_Chrome_3A finish{ambient 0}}
#else
#declare t_wheel_chrome=
texture{pigment{Gray}}
#declare t_brake_metal=
texture{pigment{Gray}}
#end



