#macro wheel(type_rim,wheel_rotation)

// *** measures ***
#local width_wheel=20;
#local radius_wheel=55.3*.5;
#local width_rim=18.5;
#local radius_rim=20;

// tyres texture
#declare t_tyre=
texture{
 pigment{
  cylindrical
  color_map{
   [0.0 Gray50]
   [0.05 Gray20]
   [1.0 Gray10*.1]
  }
  rotate 90*z
  scale radius_wheel
 }
 finish{specular .2 roughness .01}
}


// *** wheels ***
#local tyre=
union{
 difference{
  superellipsoid{
   <1,.2>
   rotate 90*y
   scale <width_wheel*.5,radius_wheel,radius_wheel>
  }
  cylinder{
   <-width_wheel*.6,0,0>
   < width_wheel*.6,0,0>
   radius_rim+.1
  }
  texture{t_tyre
  }
 }
 torus{
  radius_wheel-5,4.8
  rotate 90*z
  scale <0.8,1,1>
  translate -width_wheel*.45*x
  texture{t_tyre}
 }
}

#switch (type_rim)
 #case (1)
  #include "i_car-rim-1.inc"
  #local car_rim=
  object{car_rim_1 scale .5
   rotate -90*y
   scale <width_rim*2.5,radius_rim*2,radius_rim*2>
   translate width_rim*.25*x
  }
  #break
 #case (2)
  #include "i_car-rim-2.inc"
  #local car_rim=
  object{car_rim_2 scale .5
   rotate -90*y
   scale <width_rim*2.5,radius_rim*2,radius_rim*2>
   translate width_rim*.25*x
  }
  #break
 #case (3)
  #include "i_car-rim-3.inc"
  #local car_rim=
  object{car_rim_3 scale .5
   rotate -90*y
   scale <width_rim*2.5,radius_rim*2,radius_rim*2>
   translate width_rim*.25*x
  }
  #break
 #case (4)
  #include "i_car-rim-4.inc"
  #local car_rim=
  object{car_rim_4 scale .5
   rotate -90*y
   scale <width_rim*2.5,radius_rim*2,radius_rim*2>
   translate width_rim*.25*x
  }
  #break
 #case (5)
  #include "i_car-rim-5.inc"
  #local car_rim=
  object{car_rim_5 scale .5
   rotate -90*y
   scale <width_rim*2.5,radius_rim*2,radius_rim*2>
   translate width_rim*.25*x
  }
  #break
 #else
  #local car_rim=
  cylinder{<-.5,0,0>,<.5,0,0>,1
   scale <5,radius_rim*2,radius_rim*2>
   texture{t_metal_rim}
  }
#end

#local brakes=
cylinder{
 <-.5,0,0>,<.5,0,0>,radius_rim*.8
 texture{t_brake_metal}
}

// wheel
union{
 object{tyre}
 object{car_rim translate -width_wheel*.5*x}
 object{brakes}
 rotate wheel_rotation*x
}

#end // end of macro wheel
